<template>
  <div>
<!-- select 2 demo -->
    <b-modal
      id="modal-addAdvance"
      title="Agregar Avance"
      hide-footer
    >
      <b-form
       @submit.stop.prevent
      >
        <b-form-group
          label="Descripción"
          label-for="description"
          
        >
          <b-form-input
            id="description"
            autocomplete="off"
            maxlength="150"
            v-model="formData.description"
            :state="validationDescription"
            placeholder="Descripción"
          />
          <b-alert variant="warning" :show="showAlert">La descripción es obligatoria!</b-alert>
          <b-form-invalid-feedback :state="validationDescription">
                La descripción requiere de 10 caracteres como mínimo.
          </b-form-invalid-feedback>
        </b-form-group>
        <b-form-group
          label="Comentarios"
          label-for="comments"
        >
            <b-form-input
              id="comments"
              maxlength="250"
              autocomplete="off"
              v-model="formData.comments"
              placeholder="Comentarios"
            />
        </b-form-group>

        <b-form-group
          label="Duración del avance (horas)"
          label-for="time"
        >
            
          <b-form-input
            id="time"
            v-model="formData.time"
            :state="validationTime"
            type="number"
            onKeyUp=" if (this.value.length > 4) {this.value = this.value.slice(0, 4)} if(this.value<0){this.value= this.value * -1}"
            placeholder="Duración del avance (horas)"
          />

          <b-form-invalid-feedback :state="validationTime">
                La duración del avance debe ser mayor a 0 
          </b-form-invalid-feedback>
          
        </b-form-group>

        <b-form-group
          label="Porcentaje de avance de la actividad"
          label-for="percentage"
        >
            
          <b-form-spinbutton
            id="percentage"
            v-model="formData.percentage_advance"
            :min="percentage_advance"
            max="100"
          />
        </b-form-group>

        <b-form-group
          label="Archivos"
          label-for="files"
        >
             <b-form-file
                id="files"
                v-model="formData.files"
                placeholder="Seleccionar archivos..."
                drop-placeholder="Drop file here..."
                multiple
                accept=".jpg, .png, .jpeg, .gif, .bmp, .tif, .tiff|image/*, .pdf, .txt, .docx, .xls, .xlsx, .avi, .mp4, .3gp, .mov
                , .wmv, .flv, .webp, .f4v, .mpeg2, .avchd, .one"
              />
        </b-form-group>


        <b-button  variant="primary" @click="submit"  class="ml-1" :disabled="lockedSubmit.description || lockedSubmit.time">
            Guardar
        </b-button>
         <b-button  variant="outline-secondary" @click="cancel"  class="ml-1">
            Cancelar
        </b-button>
      </b-form>
    </b-modal>
  </div>
    
</template>

<script>
import BCardCode from '@core/components/b-card-code'
import {
  BButton, BModal, VBModal,BAlert, BForm, BFormInput, BFormGroup, BCardText,BFormDatepicker, BFormFile,BFormSpinbutton,BFormInvalidFeedback,
} from 'bootstrap-vue'
import Ripple from 'vue-ripple-directive'
import { ValidationProvider } from 'vee-validate';
export default {
  props:{
    percentage_advance:Number
  },
  name:'modal-add-advance',
  components: {
    BFormFile,
    BCardCode,
    BButton,
    BModal,
    BForm,
    BFormInput,
    BCardText,
    BAlert,
    BFormGroup,
    BFormDatepicker,
    BFormSpinbutton,
    BFormInvalidFeedback,
  },
  directives: {
    'b-modal': VBModal,
    Ripple,
  },
  data() {
    return {
        formData:{
            id:'',
            description:'',
            comments:'',
            time:0,
            percentage_advance:0,
            files:[],
        },
        defaultFormData:{
            id:'',
            description:'',
            comments:'',
            time:0,
            percentage_advance:0,
            files:[]
        },
        hasWrittenDescription:false,
        showAlert:false,
        lockedSubmit:{
          description:true,
          time:true
        }

    }
  },
  computed: {
    progress: function () {
      return this.formData.percentage_advance = this.percentage_advance
    }
  },
  methods:{
      submit(){
        if(this.formData.description===''){
          this.showAlert=true
          return
       }else{
          let alert
          if(this.formData.percentage_advance === 100){
            alert = this.$swal({
            
              title: 'Ha indicado que la actividad se ecuentra al 100%',
              text: "!La actividad será marcada como cerrada!, ¿Esta seguro que desea continuar?",
              icon: 'warning',
              showCancelButton: true,
              confirmButtonText: 'Si, guardar!',
              customClass: {
                confirmButton: 'btn btn-primary',
                cancelButton: 'btn btn-outline-danger ml-1',
              },
              buttonsStyling: false,

            })
          }else{
            alert = this.$swal({
              
              title: '¿Está seguro de guardar el avance?',
              text: "!Recuerde que únicamente podrá modificar el último avance agregado!",
              icon: 'warning',
              showCancelButton: true,
              confirmButtonText: 'Si, guardar!',
              customClass: {
                confirmButton: 'btn btn-primary',
                cancelButton: 'btn btn-outline-danger ml-1',
              },
              buttonsStyling: false,

            })
          }    
          alert.then(result => {
            if (result.value) {
              
                this.formData.id=this.$route.params.activitie

                let datos = new FormData();
                datos.append("id", this.formData.id);
                datos.append("description", this.formData.description);
                datos.append("comments", this.formData.comments);
                datos.append("time", this.formData.time);
                datos.append("percentage_advance", this.formData.percentage_advance);
                for (let i=0; i<this.formData.files.length;i++){
                  datos.append('file[]', this.formData.files[i]);
                }

                const config = { headers: { "Content-Type": "multipart/form-data" } };
              
                this.$http.post("project/activities/add/advance", datos,config).then((res) => {
                      this.$swal({
                          icon: 'success',
                          title: 'Guardado!',
                          text: 'El avance ha sido registrado correctamente.',
                          customClass: {
                            confirmButton: 'btn btn-success',
                          },
                      })
                    
                      if (res.data.message === "agregado") {
                        this.$bvModal.hide('modal-addAdvance')
                        this.formData = { ...this.defaultFormData };
                        this.hasWrittenDescription = false
                        this.showAlert = false
                        this.$emit('success', true)
                      }
                }).catch((err) => {
                    console.log(err);
                });

              } else {
              this.$swal({
                title: 'Cancelado',
                text: 'El registro no ha sido guardado',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
            }
          })
        }


        
      },
      cancel(){
        this.formData = { ...this.defaultFormData };
        this.formData.percentage_advance = this.percentage_advance
        this.hasWrittenDescription = false
        this.showAlert = false
        this.$bvModal.hide('modal-addAdvance')
      }
  },
  watch:{
    percentage_advance:function(value){
      this.formData.percentage_advance = this.percentage_advance
    }
  },
  computed:{
    validationDescription() {
        if (this.formData.description.length > 0){
          this.hasWrittenDescription = true
        } 
        if(this.hasWrittenDescription){
          if (this.formData.description.length > 9){
            this.lockedSubmit.description = false
            return true
          }else{
            this.lockedSubmit.description = true
            return false
          }
        }
      },
    validationTime() {      
      if (this.formData.time> 0){
        this.lockedSubmit.time = false
        return true
      }else{
        this.lockedSubmit.time = true
        return false
      }
        
    },
  },
  mounted(){
    this.formData.percentage_advance = this.percentage_advance
  }

}
</script>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
